Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zsms.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zsms.F90	(revision 12536)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zsms.F90	(revision 12537)
@@ -30,9 +30,9 @@
    PRIVATE
 
-   PUBLIC   p4z_sms_init   ! called in p4zsms.F90
-   PUBLIC   p4z_sms        ! called in p4zsms.F90
+   PUBLIC   p4z_sms_init   ! called in trcini_pisces.F90
+   PUBLIC   p4z_sms        ! called in trcsms_pisces.F90
 
    INTEGER ::    numco2, numnut, numnit      ! logical unit for co2 budget
-   REAL(wp) ::   alkbudget, no3budget, silbudget, ferbudget, po4budget
+   REAL(wp) ::   alkbudget, no3budget, silbudget, ferbudget, po4budget ! total budget of the different conservative elements
    REAL(wp) ::   xfact1, xfact2, xfact3
 
@@ -53,7 +53,8 @@
       !!              routines of PISCES bio-model
       !!
-      !! ** Method  : - at each new day ...
-      !!              - several calls of bio and sed ???
-      !!              - ...
+      !! ** Method  : - calls the various SMS subroutines
+      !!              - calls the sediment module (if ln_sediment)  
+      !!              - several calls of bio and sed (possible time-splitting)
+      !!              - handles the potential negative concentrations (xnegtr)
       !!---------------------------------------------------------------------
       !
@@ -72,5 +73,5 @@
         !
         IF( .NOT. ln_rsttr ) THEN
-            CALL p4z_che                              ! initialize the chemical constants
+            CALL p4z_che            ! initialize the chemical constants
             CALL ahini_for_at(hi)   !  set PH at kt=nit000
             t_oce_co2_flx_cum = 0._wp
@@ -110,9 +111,16 @@
       DO jnt = 1, nrdttrc          ! Potential time splitting if requested
          !
-         CALL p4z_bio( kt, jnt )   ! Biology
-         CALL p4z_lys( kt, jnt )   ! Compute CaCO3 saturation
+         CALL p4z_bio( kt, jnt )   ! Biological SMS
+         CALL p4z_lys( kt, jnt )   ! Compute CaCO3 saturation and dissolution
          CALL p4z_sed( kt, jnt )   ! Surface and Bottom boundary conditions
-         CALL p4z_flx( kt, jnt )   ! Compute surface fluxes
-         !
+         CALL p4z_flx( kt, jnt )   ! Compute surface air-sea fluxes
+         !
+         ! Handling of the negative concentrations
+         ! The biological SMS may generate negative concentrations
+         ! Trends are tested at each grid cell. If a negative concentrations 
+         ! is created at a grid cell, all the sources and sinks at that grid 
+         ! cell are scale to avoid that negative concentration. This approach 
+         ! is quite simplistic but it conserves mass.
+         ! ------------------------------------------------------------------
          xnegtr(:,:,:) = 1.e0
          DO jn = jp_pcs0, jp_pcs1
@@ -130,8 +138,10 @@
          !                                ! where at least 1 tracer concentration becomes negative
          !                                ! 
+         ! Concentrations are updated
          DO jn = jp_pcs0, jp_pcs1
            trb(:,:,:,jn) = trb(:,:,:,jn) + xnegtr(:,:,:) * tra(:,:,:,jn)
          END DO
         !
+        ! Trends are are reset to 0
          DO jn = jp_pcs0, jp_pcs1
             tra(:,:,:,jn) = 0._wp
@@ -153,4 +163,5 @@
 #endif
       !
+      ! If ln_sediment is set to .true. then the sediment module is called
       IF( ln_sediment ) THEN 
          !
@@ -181,8 +192,8 @@
       !!                     ***  p4z_sms_init  ***  
       !!
-      !! ** Purpose :   read PISCES namelist
-      !!
-      !! ** input   :   file 'namelist.trc.s' containing the following
-      !!             namelist: natext, natbio, natsms
+      !! ** Purpose :   read the general PISCES namelist
+      !!
+      !! ** input   :   file 'namelist_pisces' containing the following
+      !!                namelist: nampisbio, nampisdmp, nampismass 
       !!----------------------------------------------------------------------
       INTEGER :: ios                 ! Local integer output status for namelist read
@@ -268,5 +279,5 @@
       !!                   ***  ROUTINE p4z_rst  ***
       !!
-      !!  ** Purpose : Read or write variables in restart file:
+      !!  ** Purpose : Read or write specific PISCES variables in restart file:
       !!
       !!  WRITE(READ) mode:
@@ -280,8 +291,11 @@
       IF( TRIM(cdrw) == 'READ' ) THEN
          !
+         ! Read the specific variable of PISCES
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) ' p4z_rst : Read specific variables from pisces model '
          IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
          ! 
+         ! Read the pH. If not in the restart file, then it is initialized from
+         ! the initial conditions
          IF( iom_varid( numrtr, 'PH', ldstop = .FALSE. ) > 0 ) THEN
             CALL iom_get( numrtr, jpdom_autoglo, 'PH' , hi(:,:,:)  )
@@ -290,4 +304,6 @@
             CALL ahini_for_at(hi)
          ENDIF
+
+         ! Read the Si half saturation constant and the maximum Silica concentration
          CALL iom_get( numrtr, jpdom_autoglo, 'Silicalim', xksi(:,:) )
          IF( iom_varid( numrtr, 'Silicamax', ldstop = .FALSE. ) > 0 ) THEN
@@ -296,5 +312,6 @@
             xksimax(:,:) = xksi(:,:)
          ENDIF
-         !
+
+         ! Read the cumulative total flux. If not in the restart file, it is set to 0          
          IF( iom_varid( numrtr, 'tcflxcum', ldstop = .FALSE. ) > 0 ) THEN  ! cumulative total flux of carbon
             CALL iom_get( numrtr, 'tcflxcum' , t_oce_co2_flx_cum  )
@@ -303,5 +320,8 @@
          ENDIF
          !
+         ! PISCES-QUOTA specific part
          IF( ln_p5z ) THEN
+            ! Read the size of the different phytoplankton groups
+            ! If not in the restart file, they are set to 1
             IF( iom_varid( numrtr, 'sized', ldstop = .FALSE. ) > 0 ) THEN
                CALL iom_get( numrtr, jpdom_autoglo, 'sizep' , sizep(:,:,:)  )
@@ -316,4 +336,5 @@
         !
       ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN
+         ! write the specific variables of PISCES
          IF( kt == nitrst ) THEN
             IF(lwp) WRITE(numout,*)
@@ -321,12 +342,12 @@
             IF(lwp) WRITE(numout,*) '~~~~~~~'
          ENDIF
-         CALL iom_rstput( kt, nitrst, numrtw, 'PH', hi(:,:,:) )
-         CALL iom_rstput( kt, nitrst, numrtw, 'Silicalim', xksi(:,:) )
-         CALL iom_rstput( kt, nitrst, numrtw, 'Silicamax', xksimax(:,:) )
-         CALL iom_rstput( kt, nitrst, numrtw, 'tcflxcum', t_oce_co2_flx_cum )
+         CALL iom_rstput( kt, nitrst, numrtw, 'PH', hi(:,:,:) )           ! pH
+         CALL iom_rstput( kt, nitrst, numrtw, 'Silicalim', xksi(:,:) )    ! Si 1/2 saturation constant
+         CALL iom_rstput( kt, nitrst, numrtw, 'Silicamax', xksimax(:,:) ) ! Si max concentration
+         CALL iom_rstput( kt, nitrst, numrtw, 'tcflxcum', t_oce_co2_flx_cum ) ! Cumulative CO2 flux
          IF( ln_p5z ) THEN
-            CALL iom_rstput( kt, nitrst, numrtw, 'sizep', sizep(:,:,:) )
-            CALL iom_rstput( kt, nitrst, numrtw, 'sizen', sizen(:,:,:) )
-            CALL iom_rstput( kt, nitrst, numrtw, 'sized', sized(:,:,:) )
+            CALL iom_rstput( kt, nitrst, numrtw, 'sizep', sizep(:,:,:) )  ! Size of picophytoplankton
+            CALL iom_rstput( kt, nitrst, numrtw, 'sizen', sizen(:,:,:) )  ! Size of nanophytoplankton
+            CALL iom_rstput( kt, nitrst, numrtw, 'sized', sized(:,:,:) )  ! Size of diatoms
          ENDIF
       ENDIF
@@ -339,5 +360,8 @@
       !!                    ***  p4z_dmp  ***
       !!
-      !! ** purpose  : Relaxation of some tracers
+      !! ** purpose  : Relaxation of the total budget of some elements
+      !!               This routine avoids the model to drift far from the 
+      !!               observed content in various elements
+      !!               Elements that may be relaxed : Alk, P, N, Si
       !!----------------------------------------------------------------------
       !
@@ -345,5 +369,5 @@
       !
       REAL(wp) ::  alkmean = 2426.     ! mean value of alkalinity ( Glodap ; for Goyet 2391. )
-      REAL(wp) ::  po4mean = 2.165     ! mean value of phosphates
+      REAL(wp) ::  po4mean = 2.165     ! mean value of phosphate
       REAL(wp) ::  no3mean = 30.90     ! mean value of nitrate
       REAL(wp) ::  silmean = 91.51     ! mean value of silicate
@@ -368,13 +392,17 @@
             zsilsumn = glob_sum( 'p4zsms', trn(:,:,:,jpsil) * cvol(:,:,:)  ) * zarea
  
+            ! Correct the trn mean content of alkalinity
             IF(lwp) WRITE(numout,*) '       TALKN mean : ', zalksumn
             trn(:,:,:,jptal) = trn(:,:,:,jptal) * alkmean / zalksumn
 
+            ! Correct the trn mean content of PO4
             IF(lwp) WRITE(numout,*) '       PO4N  mean : ', zpo4sumn
             trn(:,:,:,jppo4) = trn(:,:,:,jppo4) * po4mean / zpo4sumn
 
+            ! Correct the trn mean content of NO3
             IF(lwp) WRITE(numout,*) '       NO3N  mean : ', zno3sumn
             trn(:,:,:,jpno3) = trn(:,:,:,jpno3) * no3mean / zno3sumn
 
+            ! Correct the trn mean content of SiO3
             IF(lwp) WRITE(numout,*) '       SiO3N mean : ', zsilsumn
             trn(:,:,:,jpsil) = MIN( 400.e-6,trn(:,:,:,jpsil) * silmean / zsilsumn )
@@ -388,13 +416,17 @@
  
                IF(lwp) WRITE(numout,*) ' '
+               ! Correct the trb mean content of alkalinity
                IF(lwp) WRITE(numout,*) '       TALKB mean : ', zalksumb
                trb(:,:,:,jptal) = trb(:,:,:,jptal) * alkmean / zalksumb
 
+               ! Correct the trb mean content of PO4
                IF(lwp) WRITE(numout,*) '       PO4B  mean : ', zpo4sumb
                trb(:,:,:,jppo4) = trb(:,:,:,jppo4) * po4mean / zpo4sumb
 
+               ! Correct the trb mean content of NO3
                IF(lwp) WRITE(numout,*) '       NO3B  mean : ', zno3sumb
                trb(:,:,:,jpno3) = trb(:,:,:,jpno3) * no3mean / zno3sumb
 
+               ! Correct the trb mean content of SiO3
                IF(lwp) WRITE(numout,*) '       SiO3B mean : ', zsilsumb
                trb(:,:,:,jpsil) = MIN( 400.e-6,trb(:,:,:,jpsil) * silmean / zsilsumb )
@@ -435,6 +467,6 @@
       ENDIF
 
+      ! Compute the budget of NO3
       IF( iom_use( "pno3tot" ) .OR. ( ln_check_mass .AND. kt == nitend )  ) THEN
-         !   Compute the budget of NO3, ALK, Si, Fer
          IF( ln_p4z ) THEN
             zwork(:,:,:) =    trn(:,:,:,jpno3) + trn(:,:,:,jpnh4)                      &
@@ -454,4 +486,5 @@
       ENDIF
       !
+      ! Compute the budget of PO4
       IF( iom_use( "ppo4tot" ) .OR. ( ln_check_mass .AND. kt == nitend )  ) THEN
          IF( ln_p4z ) THEN
@@ -472,4 +505,5 @@
       ENDIF
       !
+      ! Compute the budget of SiO3
       IF( iom_use( "psiltot" ) .OR. ( ln_check_mass .AND. kt == nitend )  ) THEN
          zwork(:,:,:) =  trn(:,:,:,jpsil) + trn(:,:,:,jpgsi) + trn(:,:,:,jpdsi) 
@@ -488,4 +522,5 @@
       ENDIF
       !
+      ! Compute the budget of Iron
       IF( iom_use( "pfertot" ) .OR. ( ln_check_mass .AND. kt == nitend )  ) THEN
          zwork(:,:,:) =   trn(:,:,:,jpfer) + trn(:,:,:,jpnfe) + trn(:,:,:,jpdfe)   &
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p5zlim.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p5zlim.F90	(revision 12536)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p5zlim.F90	(revision 12537)
@@ -2,5 +2,6 @@
    !!======================================================================
    !!                         ***  MODULE p5zlim  ***
-   !! TOP :   PISCES with variable stoichiometry 
+   !! TOP :   PISCES-QUOTA : Computes the various nutrient limitation terms
+   !!                        of phytoplankton
    !!======================================================================
    !! History :   1.0  !  2004     (O. Aumont) Original code
@@ -14,5 +15,5 @@
    USE oce_trc         ! Shared ocean-passive tracers variables
    USE trc             ! Tracers defined
-   USE p4zlim
+   USE p4zlim          ! Nutrient limitation 
    USE sms_pisces      ! PISCES variables
    USE iom             !  I/O manager
@@ -21,7 +22,7 @@
    PRIVATE
 
-   PUBLIC p5z_lim    
-   PUBLIC p5z_lim_init    
-   PUBLIC p5z_lim_alloc
+   PUBLIC p5z_lim           ! called in p4zbio.F90  
+   PUBLIC p5z_lim_init      ! called in trcsms_pisces.F90 
+   PUBLIC p5z_lim_alloc     ! called in trcini_pisces.F90
 
    !! * Shared module variables
@@ -72,23 +73,23 @@
 
    !!* Phytoplankton nutrient limitation terms
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xpicono3   !: ???
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xpiconh4   !: ???
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xpicopo4   !: ???
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xnanodop   !: ???
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xpicodop   !: ???
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xdiatdop   !: ???
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xnanofer   !: ???
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xpicofer   !: ???
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xdiatfer   !: ???
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimpic    !: ???
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimpics   !: ???
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimphys   !: ???
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimdias   !: ???
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimpfe    !: ???
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   fvnuptk
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   fvpuptk
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   fvduptk
-
-   ! Coefficient for iron limitation
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xpicono3   !: Limitation of NO3 uptake by picophyto
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xpiconh4   !: Limitation of NH4 uptake by picophyto
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xpicopo4   !: Limitation of PO4 uptake by picophyto
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xnanodop   !: Limitation of DOP uptake by nanophyto
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xpicodop   !: Limitation of DOP uptake by picophyto
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xdiatdop   !: Limitation of DOP uptake by diatoms
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xnanofer   !: Limitation of Fe uptake by nanophyto
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xpicofer   !: Limitation of Fe uptake by picophyto
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xdiatfer   !: Limitation of Fe uptake by diatoms
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimpic    !: Limitation of picophyto PP by nutrients
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimpics   !: Limitation of picophyto PP by nutrients
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimphys   !: Limitation of nanophyto PP by nutrients
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimdias   !: Limitation of diatoms PP by nutrients
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimpfe    !: Limitation of picophyto PP by Fe
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   fvnuptk    !: Maximum potential uptake rate of nanophyto
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   fvpuptk    !: Maximum potential uptake rate of picophyto
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   fvduptk    !: Maximum potential uptake rate of diatoms
+
+   ! Coefficient for iron limitation following Flynn and Hipkin (1999)
    REAL(wp) ::  xcoef1   = 0.00167  / 55.85
    REAL(wp) ::  xcoef2   = 1.21E-5 * 14. / 55.85 / 7.625 * 0.5 * 1.5
@@ -110,6 +111,6 @@
       !!                approach. The quota model is derived from theoretical
       !!                models proposed by Pahlow and Oschlies (2009) and 
-      !!                Flynn (2001). Various adaptations from several publications
-      !!                by these authors have been also adopted. 
+      !!                Flynn (2001). Various adaptations from several 
+      !!                publications by these authors have been also adopted. 
       !!
       !! ** Method  : Quota based approach. The quota model is derived from 
@@ -145,6 +146,7 @@
             DO ji = 1, jpi
                ! 
-               ! Tuning of the iron concentration to a minimum level that is set to the detection limit
-               !-------------------------------------
+               ! Tuning of the iron concentration to a minimum level that
+               ! is set to the detection limit
+               ! --------------------------------------------------------
                zno3    = trb(ji,jj,jk,jpno3) / 40.e-6
                zferlim = MAX( 3e-11 * zno3 * zno3, 5e-12 )
@@ -152,6 +154,6 @@
                trb(ji,jj,jk,jpfer) = MAX( trb(ji,jj,jk,jpfer), zferlim )
 
-               ! Computation of the mean relative size of each community
-               ! -------------------------------------------------------
+               ! Computation of the Chl/C ratio of each phytoplankton group
+               ! ----------------------------------------------------------
                z1_trnphy   = 1. / ( trb(ji,jj,jk,jpphy) + rtrn )
                z1_trnpic   = 1. / ( trb(ji,jj,jk,jppic) + rtrn )
@@ -161,7 +163,10 @@
                zdiatchl = trb(ji,jj,jk,jpdch) * z1_trndia
 
-               ! Computation of a variable Ks for iron on diatoms taking into account
-               ! that increasing biomass is made of generally bigger cells
-               !------------------------------------------------
+               ! Computation of a variable Ks for the different phytoplankton
+               ! group as a function of their relative size. Allometry
+               ! from Edwards et al. (2012)
+               ! ------------------------------------------------------------
+
+               ! diatoms
                zsized            = sized(ji,jj,jk)**0.81
                zconcdfe          = concdfer * zsized
@@ -170,4 +175,5 @@
                zconc0dpo4        = concdpo4 * zsized
 
+               ! picophytoplankton
                zsizep            = sizep(ji,jj,jk)**0.81
                zconcpfe          = concpfer * zsizep
@@ -176,4 +182,5 @@
                zconc0ppo4        = concppo4 * zsizep
 
+               ! nanophytoplankton
                zsizen            = sizen(ji,jj,jk)**0.81
                zconcnfe          = concnfer * zsizen
@@ -193,6 +200,9 @@
 
                ! Computation of the optimal allocation parameters
-               ! Based on the different papers by Pahlow et al., and Smith et al.
-               ! -----------------------------------------------------------------
+               ! Based on the different papers by Pahlow et al., and 
+               ! Smith et al.
+               ! ---------------------------------------------------
+
+               ! Nanophytoplankton
                znutlim = MAX( trb(ji,jj,jk,jpnh4) / zconc0nnh4,    &
                  &         trb(ji,jj,jk,jpno3) / zconc0n)
@@ -202,4 +212,6 @@
                znutlim = biron(ji,jj,jk) / zconcnfe
                fananof = MAX(0.01, MIN(0.99, 1. / ( SQRT(znutlim) + 1.) ) )
+
+               ! Picophytoplankton
                znutlim = MAX( trb(ji,jj,jk,jpnh4) / zconc0pnh4,    &
                  &         trb(ji,jj,jk,jpno3) / zconc0p)
@@ -209,4 +221,6 @@
                znutlim = biron(ji,jj,jk) / zconcpfe
                fapicof = MAX(0.01, MIN(0.99, 1. / ( SQRT(znutlim) + 1.) ) )
+
+               ! Diatoms
                znutlim = MAX( trb(ji,jj,jk,jpnh4) / zconc1dnh4,    &
                  &         trb(ji,jj,jk,jpno3) / zconc1d )
@@ -216,7 +230,8 @@
                znutlim = biron(ji,jj,jk) / zconcdfe
                fadiatf = MAX(0.01, MIN(0.99, 1. / ( SQRT(znutlim) + 1.) ) )
-               !
-               ! Michaelis-Menten Limitation term for nutrients Small bacteria
-               ! -------------------------------------------------------------
+
+               ! Michaelis-Menten Limitation term by nutrients of
+               ! heterotrophic bacteria
+               ! -------------------------------------------------
                zbactnh4 = trb(ji,jj,jk,jpnh4) / ( concbnh4 + trb(ji,jj,jk,jpnh4) )
                zbactno3 = trb(ji,jj,jk,jpno3) / ( concbno3 + trb(ji,jj,jk,jpno3) ) * (1. - zbactnh4)
@@ -226,9 +241,14 @@
                zlim3    = biron(ji,jj,jk) / ( concbfe + biron(ji,jj,jk) )
                zlim4    = trb(ji,jj,jk,jpdoc) / ( xkdoc   + trb(ji,jj,jk,jpdoc) )
+               ! Xlimbac is used for DOC solubilization whereas xlimbacl
+               ! is used for all the other bacterial-dependent terms
+               ! -------------------------------------------------------
                xlimbacl(ji,jj,jk) = MIN( zlim1, zlim2, zlim3 )
                xlimbac (ji,jj,jk) = xlimbacl(ji,jj,jk) * zlim4
-               !
-               ! Michaelis-Menten Limitation term for nutrients Small flagellates
-               ! -----------------------------------------------
+               
+               ! Michaelis-Menten Limitation term by nutrients: Nanophyto
+               ! --------------------------------------------------------
+               !
+               ! Limitation of N based nutrients uptake (NO3 and NH4)
                zfalim = (1.-fanano) / fanano
                xnanonh4(ji,jj,jk) = (1. - fanano) * trb(ji,jj,jk,jpnh4) / ( zfalim * zconc0nnh4 + trb(ji,jj,jk,jpnh4) )
@@ -236,4 +256,5 @@
                &                    * (1. - xnanonh4(ji,jj,jk))
                !
+               ! Limitation of P based nutrients (PO4 and DOP)
                zfalim = (1.-fananop) / fananop
                xnanopo4(ji,jj,jk) = (1. - fananop) * trb(ji,jj,jk,jppo4) / ( trb(ji,jj,jk,jppo4) + zfalim * zconc0npo4 )
@@ -242,7 +263,11 @@
                xnanodop(ji,jj,jk) = 0.
                !
+               ! Limitation of Fe uptake
                zfalim = (1.-fananof) / fananof
                xnanofer(ji,jj,jk) = (1. - fananof) * biron(ji,jj,jk) / ( biron(ji,jj,jk) + zfalim * zconcnfe )
                !
+               ! The minimum iron quota depends on the size of PSU, respiration
+               ! and the reduction of nitrate following the parameterization 
+               ! proposed by Flynn and Hipkin (1999)
                zratiof   = trb(ji,jj,jk,jpnfe) * z1_trnphy
                zqfemn = xcoef1 * znanochl + xcoef2 + xcoef3 * xnanono3(ji,jj,jk)
@@ -257,16 +282,20 @@
                &          / (xqnnmax(ji,jj,jk) - xqnnmin(ji,jj,jk) ) ) * xqnnmax(ji,jj,jk)  &
                &          / (zration + rtrn)
-               !  The value of the optimal quota in the formulation below
-               !  has been found by solving a non linear equation
+               ! The value of the optimal quota in the formulation below
+               ! has been found by solving a non linear equation
                zlim1f = max(0., ( 1.086 - xqnnmin(ji,jj,jk) )  &
                &          / (xqnnmax(ji,jj,jk) - xqnnmin(ji,jj,jk) ) ) * xqnnmax(ji,jj,jk)
                zlim3  = MAX( 0.,( zratiof - zqfemn ) / qfnopt )
+               ! computation of the various limitation terms of nanophyto
+               ! growth and PP
                xlimnfe (ji,jj,jk) = MIN( 1., zlim3 )
                xlimphy (ji,jj,jk) = MIN( 1., zlim1, zlim3 )
                xlimphys(ji,jj,jk) = MIN( 1., zlim1/( zlim1f + rtrn ), zlim3 )
                xlimnpn (ji,jj,jk) = MIN( 1., zlim1)
-               !
-               ! Michaelis-Menten Limitation term for nutrients picophytoplankton
-               ! ----------------------------------------------------------------
+
+               ! Michaelis-Menten Limitation term by nutrients: Picophyto
+               ! --------------------------------------------------------
+               !
+               ! Limitation of N based nutrients uptake (NO3 and NH4) 
                zfalim = (1.-fapico) / fapico 
                xpiconh4(ji,jj,jk) = (1. - fapico) * trb(ji,jj,jk,jpnh4) / ( zfalim * zconc0pnh4 + trb(ji,jj,jk,jpnh4) )
@@ -274,4 +303,5 @@
                &                    * (1. - xpiconh4(ji,jj,jk))
                !
+               ! Limitation of P based nutrients uptake (PO4 and DOP)
                zfalim = (1.-fapicop) / fapicop 
                xpicopo4(ji,jj,jk) = (1. - fapicop) * trb(ji,jj,jk,jppo4) / ( trb(ji,jj,jk,jppo4) + zfalim * zconc0ppo4 )
@@ -283,4 +313,7 @@
                xpicofer(ji,jj,jk) = (1. - fapicof) * biron(ji,jj,jk) / ( biron(ji,jj,jk) + zfalim * zconcpfe )
                !
+               ! The minimum iron quota depends on the size of PSU, respiration
+               ! and the reduction of nitrate following the parameterization 
+               ! proposed by Flynn and Hipkin (1999)
                zratiof   = trb(ji,jj,jk,jppfe) * z1_trnpic
                zqfemp = xcoef1 * zpicochl + xcoef2 + xcoef3 * xpicono3(ji,jj,jk)
@@ -295,16 +328,21 @@
                &          / (xqnpmax(ji,jj,jk) - xqnpmin(ji,jj,jk) ) ) * xqnpmax(ji,jj,jk)  &
                &          / (zration + rtrn)
-               !  The value of the optimal quota in the formulation below
-               !  has been found by solving a non linear equation
+               ! The value of the optimal quota in the formulation below
+               ! has been found by solving a non linear equation
                zlim1f   = max(0., (1.367 - xqnpmin(ji,jj,jk) )  &
                &          / (xqnpmax(ji,jj,jk) - xqnpmin(ji,jj,jk) ) ) * xqnpmax(ji,jj,jk)
                zlim3    = MAX( 0.,( zratiof - zqfemp ) / qfpopt )
+
+               ! computation of the various limitation terms of picophyto
+               ! growth and PP
                xlimpfe (ji,jj,jk) = MIN( 1., zlim3 )
                xlimpic (ji,jj,jk) = MIN( 1., zlim1, zlim3 )
                xlimnpp (ji,jj,jk) = MIN( 1., zlim1 )
                xlimpics(ji,jj,jk) = MIN( 1., zlim1/( zlim1f + rtrn ), zlim3 )
-               !
-               !   Michaelis-Menten Limitation term for nutrients Diatoms
-               !   ------------------------------------------------------
+
+               ! Michaelis-Menten Limitation term by nutrients : Diatoms
+               ! -------------------------------------------------------
+               !
+               ! Limitation of N based nutrients uptake (NO3 and NH4)
                zfalim = (1.-fadiat) / fadiat 
                xdiatnh4(ji,jj,jk) = (1. - fadiat) * trb(ji,jj,jk,jpnh4) / ( zfalim * zconc1dnh4 + trb(ji,jj,jk,jpnh4) )
@@ -312,4 +350,5 @@
                &                    * (1. - xdiatnh4(ji,jj,jk))
                !
+               ! Limitation of P based nutrients uptake (PO4 and DOP)
                zfalim = (1.-fadiatp) / fadiatp
                xdiatpo4(ji,jj,jk) = (1. - fadiatp) * trb(ji,jj,jk,jppo4) / ( trb(ji,jj,jk,jppo4) + zfalim * zconc0dpo4 )
@@ -318,7 +357,11 @@
                xdiatdop(ji,jj,jk) = 0.
                !
+               ! Limitation of Fe uptake
                zfalim = (1.-fadiatf) / fadiatf
                xdiatfer(ji,jj,jk) = (1. - fadiatf) * biron(ji,jj,jk) / ( biron(ji,jj,jk) + zfalim * zconcdfe )
                !
+               ! The minimum iron quota depends on the size of PSU, respiration
+               ! and the reduction of nitrate following the parameterization 
+               ! proposed by Flynn and Hipkin (1999)
                zratiof   = trb(ji,jj,jk,jpdfe) * z1_trndia
                zqfemd = xcoef1 * zdiatchl + xcoef2 + xcoef3 * xdiatno3(ji,jj,jk)
@@ -333,6 +376,6 @@
                &          / (xqndmax(ji,jj,jk) - xqndmin(ji,jj,jk) ) )   &
                &          * xqndmax(ji,jj,jk) / (zration + rtrn)
-               !  The value of the optimal quota in the formulation below
-               !  has been found by solving a non linear equation
+               ! The value of the optimal quota in the formulation below
+               ! has been found by solving a non linear equation
                zlim1f   = max(0., (1.077 - xqndmin(ji,jj,jk) )    &
                &          / (xqndmax(ji,jj,jk) - xqndmin(ji,jj,jk) ) )   &
@@ -340,4 +383,6 @@
                zlim3    = trb(ji,jj,jk,jpsil) / ( trb(ji,jj,jk,jpsil) + xksi(ji,jj) )
                zlim4    = MAX( 0., ( zratiof - zqfemd ) / qfdopt )
+               ! computation of the various limitation terms of diatoms
+               ! growth and PP
                xlimdfe(ji,jj,jk) = MIN( 1., zlim4 )
                xlimdia(ji,jj,jk) = MIN( 1., zlim1, zlim3, zlim4 )
@@ -357,6 +402,7 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               ! Size estimation of nanophytoplankton
-               ! ------------------------------------
+               ! Size estimation of nanophytoplankton based on total biomass
+               ! Assumes that larger biomass implies addition of larger cells
+               ! ------------------------------------------------------------
                zcoef = trb(ji,jj,jk,jpphy) - MIN(xsizephy, trb(ji,jj,jk,jpphy) )
                sizena(ji,jj,jk) = 1. + ( xsizern -1.0 ) * zcoef / ( xsizephy + zcoef )
@@ -373,6 +419,7 @@
 
 
-               ! Size estimation of picophytoplankton
-               ! ------------------------------------
+               ! Size estimation of picophytoplankton based on total biomass
+               ! Assumes that larger biomass implies addition of larger cells
+               ! ------------------------------------------------------------
                zcoef = trb(ji,jj,jk,jppic) - MIN(xsizepic, trb(ji,jj,jk,jppic) )
                sizepa(ji,jj,jk) = 1. + ( xsizerp -1.0 ) * zcoef / ( xsizepic + zcoef )
@@ -389,6 +436,7 @@
                xqppmax(ji,jj,jk) = MIN( qppmax, xqppmax(ji,jj,jk) )
 
-               ! Size estimation of diatoms
-               ! --------------------------
+               ! Size estimation of diatoms based on total biomass
+               ! Assumes that larger biomass implies addition of larger cells
+               ! ------------------------------------------------------------
                zcoef = trb(ji,jj,jk,jpdia) - MIN(xsizedia, trb(ji,jj,jk,jpdia) )
                sized(ji,jj,jk) = 1. + ( xsizerd - 1.0 ) * zcoef / ( xsizedia + zcoef )
@@ -412,4 +460,6 @@
 
       ! Compute the fraction of nanophytoplankton that is made of calcifiers
+      ! This is a purely adhoc formulation described in Aumont et al. (2015)
+      ! This fraction depends on nutrient limitation, light, temperature
       ! --------------------------------------------------------------------
       DO jk = 1, jpkm1
@@ -441,4 +491,9 @@
                   &                                / ( oxymin + trb(ji,jj,jk,jpoxy) )  )
                nitrfac(ji,jj,jk) = MIN( 1., nitrfac(ji,jj,jk) )
+               !
+               ! redox factor computed from NO3 levels
+               nitrfac2(ji,jj,jk) = MAX( 0.e0,       ( 1.E-6 - trb(ji,jj,jk,jpno3) )  &
+                  &                                / ( 1.E-6 + trb(ji,jj,jk,jpno3) ) )
+               nitrfac2(ji,jj,jk) = MIN( 1., nitrfac2(ji,jj,jk) )
             END DO
          END DO
